#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#define MAXN     32000
#define MAXVAL   MAXN

int perm[MAXN], zo[MAXN];
int n, cost;

void read_in(void)
{
	int a[MAXN], cnt[MAXVAL + 1], i;
	
	freopen("invsort.in", "r", stdin);
	scanf("%d", &n);
	assert((n >= 1) && (n <= MAXN));
	for(i = 0; i < n; i++) {
		scanf("%d", a + i);
		assert((a[i] >= 0) && (a[i] < MAXVAL));
	}
	memset(cnt, 0, sizeof(cnt));
	for(i = 0; i < n; i++)
		cnt[a[i] + 1]++;
	for(i = 1; i < MAXVAL; i++)
		cnt[i] += cnt[i - 1];
	for(i = 0; i < n; i++)
		perm[i] = (cnt[a[i]]++);
}

void reverse(int lo, int hi)
{
	int mid = (hi + lo) / 2;
	int k, x, tmp;

	printf("%d %d\n", lo + 1, hi);
	cost += (hi - lo);
	
	for(k = lo; k < mid; k++) {
		x = (hi - 1) - (k - lo);
		tmp = zo[k], zo[k] = zo[x], zo[x] = tmp;
		tmp = perm[k], perm[k] = perm[x], perm[x] = tmp;
	}
}

void sort_zo(int lo, int hi)
{
	int mid = (hi + lo) / 2;
	int i, j;

	assert(hi > lo);
	if(hi == lo + 1)
		return;
	sort_zo(lo, mid);
	sort_zo(mid, hi);
	for(j = mid; (j < hi) && !zo[j]; j++) ;
	for(i = mid - 1; (i >= lo) && zo[i]; i--) ;
	if(((++i) == mid) || (j == mid))
		return;
	reverse(i, j);

	for(i = lo; i < hi - 1; i++)
		assert(zo[i] <= zo[i + 1]);
}

void sort_perm(int lo, int hi)
{
	int mid = (hi + lo) / 2;
	int i;

	if(hi == lo + 1)
		return;
	for(i = lo; i < hi; i++)
		zo[i] = (perm[i] >= mid);
	sort_zo(lo, hi);

	for(i = lo; i < mid; i++)
		assert(perm[i] < mid);
	for(i = mid; i < hi; i++)
		assert(perm[i] >= mid);
	
	sort_perm(lo, mid);
	sort_perm(mid, hi);

	for(i = lo; i < hi; i++)
		assert(perm[i] == i);
}

int main()
{
	read_in();
	freopen("invsort.out", "w", stdout);
	sort_perm(0, n);

	fprintf(stderr, "cost: %d\n", cost);
	return(0);
}
