/***MEM:S***/

/*
Sea randomized O(N*M) implementation. O(N) Memory

by Radu Berinde
*/
#pragma option -f287


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define select belea

#ifdef __BORLANDC__
#pragma option -3 -O2
#endif

#define sqr(x) ((x)*(x))

#define VSIZE 401

typedef struct vessel
{
    double x, y;
} vessel;

vessel V[VSIZE];
int N;
long M;
double Lx;
int Ln;

double D[VSIZE];
int Nr;

double select(int n)
{
    double x, t;
    int i, j, l, r, p;
    
    for (l = 0, r = Nr-1; l < r; )
    {
        p = l + rand() % (r-l+1);
        x = D[p], D[p] = D[r], D[r] = x;
        i = l, j = r;
        while (1)
        {
            while (i < j && D[i] <= x) i++;
            while (i < j && x <= D[j]) j--;
            if (i >= j) break;
            t = D[i], D[i] = D[j], D[j] = t;
        }
        if (n < i)
            r = i-1;
        else
            l = i;
    }
    return D[l];
}

int cmpv(const void *a, const void *b)
{
    return ((vessel *) a)->x < ((vessel *) b)->x ? -1 : 1;
}

double solve()
{
    int i;
    for (; Nr < N && V[Nr].x < Lx; Nr++);
    
    for (i = 0; i < Nr; i++)
        D[i] = sqr(Lx - V[i].x) + sqr(V[i].y);
    return sqrt(select(Ln-1));
}


void read_and_solve()
{
    int i;
    FILE *fi = fopen("sea.in", "rt");
    FILE *fo = fopen("sea.out", "wt");
    
    fscanf(fi, "%d %ld", &N, &M);
    for (i = 0; i < N; i++)
        fscanf(fi, "%lf %lf", &V[i].x, &V[i].y);
    qsort(V, N, sizeof(vessel), cmpv);
    
    while (M--)
    {
        fscanf(fi, "%lf %d", &Lx, &Ln);
        fprintf(fo, "%.4f\n", solve());
    }
    fclose(fi);
    fclose(fo);
}


int main()
{
    read_and_solve();
    return 0;
}
