Program _BASE3_;

const filein = 'base3.in';
      fileout = 'base3.out';
      MAXLEN = 16000;
      MAXNUM = 3;
      MAXHEAP = 100000;
      infinit = 1000000000;

var min, where : array [1..MAXNUM, 1..2, 0..MAXLEN] of longint;
    whoi, whoj, whot : array [1..MAXHEAP] of integer;
    num : array [1..MAXNUM, 1..MAXLEN] of byte;
    len : array [1..MAXNUM] of longint;
    i, j, k, n, n1, t, nexti, nextj, nextt, newv, minlen, dimheap : longint;
    ch : char;

procedure up(poz : longint);
var tata : longint;
    i, j, t : integer;
begin
tata := poz shr 1;
if (tata = 0) then
  tata := poz;

while (min[whoi[tata], whot[tata], whoj[tata]] >
       min[whoi[poz], whot[poz], whoj[poz]]) do
  begin
    i := whoi[tata];
    t := whot[tata];
    j := whoj[tata];
    whoi[tata] := whoi[poz];
    whot[tata] := whot[poz];
    whoj[tata] := whoj[poz];
    whoi[poz] := i;
    whot[poz] := t;
    whoj[poz] := j;

    where[whoi[tata], whot[tata], whoj[tata]] := tata;
    where[whoi[poz], whot[poz], whoj[poz]] := poz;

    poz := tata;
    tata := poz shr 1;
    if (tata = 0) then
      tata := poz;
  end;
end;

procedure down(poz : longint);
var i, j, t : integer;
    v, v1, v2, p1, p2 : longint;
   ok : boolean;
begin
ok := false;
while (not ok) do
  begin
    ok := true;

    p1 := poz shl 1;
    if (p1 <= dimheap) then
      v1 := min[whoi[p1], whot[p1], whoj[p1]]
    else
      v1 := infinit;

    p2 := p1 + 1;
    if (p2 <= dimheap) then
      v2 := min[whoi[p2], whot[p2], whoj[p2]]
    else
      v2 := infinit;

    v := min[whoi[poz], whot[poz], whoj[poz]];

    if (v1 <= v2) and (v1 < v) then
      begin
        i := whoi[p1];
        t := whot[p1];
        j := whoj[p1];
        whoi[p1] := whoi[poz];
        whot[p1] := whot[poz];
        whoj[p1] := whoj[poz];
        whoi[poz] := i;
        whot[poz] := t;
        whoj[poz] := j;

        where[whoi[p1], whot[p1], whoj[p1]] := p1;
        where[whoi[poz], whot[poz], whoj[poz]] := poz;

        poz := p1;
        ok := false;
      end
    else
    if (v2 <= v1) and (v2 < v) then
      begin
        i := whoi[p2];
        t := whot[p2];
        j := whoj[p2];
        whoi[p2] := whoi[poz];
        whot[p2] := whot[poz];
        whoj[p2] := whoj[poz];
        whoi[poz] := i;
        whot[poz] := t;
        whoj[poz] := j;

        where[whoi[p2], whot[p2], whoj[p2]] := p2;
        where[whoi[poz], whot[poz], whoj[poz]] := poz;

        poz := p2;
        ok := false;
      end;
  end;
end;

procedure insheap(i, t, j : integer);
begin
inc(dimheap);
whoi[dimheap] := i;
whoj[dimheap] := j;
whot[dimheap] := t;
where[i, t, j] := dimheap;

up(dimheap);
end;

procedure delmin;
begin
whoi[1] := whoi[dimheap];
whoj[1] := whoj[dimheap];
whot[1] := whot[dimheap];
where[whoi[1], whot[1], whoj[1]] := 1;

dec(dimheap);

if (dimheap > 0) then
  down(1);
end;

begin
{ read input data }
assign(input, filein);
reset(input);

n1 := 0;
for i := 1 to 3 do
  begin
    len[i] := 0;
    while (not seekeoln(input)) and (not seekeof(input)) do
      begin
        repeat
          read(ch);
        until (ch in ['0'..'2']);

        inc(len[i]);
        num[i, len[i]] := ord(ch) - 48;

        if (ch = '1') then
          inc(n1);
      end;
    readln;
  end;
close(input);

{ calculeaza }
for i := 1 to 3 do
  for j := 1 to 2 do
    for k := 0 to MAXLEN do
      begin
        min[i, j, k] := infinit;
        where[i, j, k] := 0;
      end;

min[1, 2, 0] := 0;

dimheap := 0;

insheap(1, 2, 0);

while (dimheap > 0) do
  begin
    i := whoi[1];
    j := whoj[1];
    t := whot[1];

    for k := 1 to 3 do
      begin
        nexti := i;
        nextj := j;
        nextt := t;
        newv := min[i, t, j] + len[k];

        if (t = 1) then
          begin
            if (len[k] > len[i] - j) then
              begin
                nexti := k;
                nextj := len[k] - (len[i] - j);
                nextt := 2;
              end
            else
            if (len[k] < len[i] - j) then
              begin
                nexti := i;
                nextj := j + len[k];
                nextt := 1;
              end;
          end
        else
          begin
            if (len[k] > j) then
              begin
                nexti := k;
                nextj := j;
                nextt := 1;
              end
            else
            if (len[k] < j) then
              begin
                nexti := i;
                nextj := j - len[k];
                nextt := 2;
              end;
          end;

        if (newv < min[nexti, nextt, nextj]) then
          begin
            min[nexti, nextt, nextj] := newv;

            if (where[nexti, nextt, nextj] > 0) then
              up(where[nexti, nextt, nextj])
            else
              insheap(nexti, nextt, nextj);
          end;
      end;

    delmin;
  end;

{ cauta rezultatul }
minlen := infinit;
for i := 1 to MAXNUM do
  for j := 0 to len[i] do
    begin
      if (min[i, 1, j] < minlen) and
         ((len[i] - j) and 1 = 1) and
         (num[i, (j + len[i] + 1) shr 1] = 1) then
        begin
          minlen := min[i, 1, j];
          nexti := i;
          nextj := j;
          nextt := 1;
        end;

      if (min[i, 2, j] < minlen) and
         (j and 1 = 1) and (num[i, (j + 1) shr 1] = 1) then
        begin
          minlen := min[i, 2, j];
          nexti := i;
          nextj := j;
          nextt := 2;
        end;
    end;

{ afisaza rezultatul }
writeln(n1, ' : ', nextt, ' ', nextj, ' ', nextt);

assign(output, fileout);
rewrite(output);

if (minlen = infinit) then
  writeln(0)
else
  begin
    writeln(minlen);
  end;

close(output);
end.